include:
  - component: $CI_SERVER_FQDN/computing/gitlab/components/toolkit/license-check@main
  # https://git.ligo.org/explore/catalog/computing/gitlab/components/mkdocs
  - component: $CI_SERVER_FQDN/computing/gitlab/components/markdownlint/markdownlint@2
    inputs:
      fail_on_findings: false
      glob: "'**/*.md' '!**/README.md'"
      job_name: markdownlint
  - component: $CI_SERVER_FQDN/computing/gitlab/components/mkdocs/build@main
    inputs:
      mkdocs_options: "--clean --strict --verbose"
      requirements: "-r docs/requirements.txt"

# -- example pipelines

example:
  stage: test
  needs: []
  parallel:
    matrix:
      - EXAMPLE_NAME:
        - build
        - components
        - all
  trigger:
    include: /example/.gitlab-ci.$EXAMPLE_NAME.yml
    strategy: depend

# -- release

release:
  stage: deploy
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  rules:
    # only when running from a tag in the upstream project namespace
    - if: '$CI_PROJECT_NAMESPACE == "computing/gitlab/components" && $CI_COMMIT_TAG'
  script: echo "Creating release $CI_COMMIT_TAG"
  release:
    tag_name: "$CI_COMMIT_TAG"
    description: "Release $CI_COMMIT_TAG of $CI_PROJECT_PATH CI/CD component"

# -- trigger

rebuild-computing-guide:
  stage: deploy
  trigger: computing/guide
  variables:
    UPDATE_SUBMODULES: 1
  rules:
    # only for changes to the default branch that impact the documentation
    - if: '$CI_PROJECT_NAMESPACE == "computing/gitlab/components" && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      changes:
        - mkdocs*.yml
        - docs/
